<div class="chatbot">
    <div class="d-none d-sm-block">
        <h1 class="text-center">Programming language chatbot</h1>
        <h5 class="text-center">"I will help you select the best technology for your next project!"</h5>
    </div>
    <div class="d-sm-none">
        <h6 class="text-center"><i class="fas fa-robot"></i> Programming language chatbot</h6>
    </div>
    <div id="frame">
        <div class="content">
            {snippet frameFlashes}
                {foreach $flashes as $flash}
                    <div class="alert frame-flash">
                        <i class="icon fas fa-{\App\Enum\EFlashMessageTypes::getFlashIcon($flash->type)}"></i> {$flash->message}
                    </div>
                {/foreach}
                <script>
                    $(document).ready(function(){
                        $(".alert").delay(5000).slideUp(300);
                    });
                </script>
            {/snippet}
            <div class="messages">
                <ul>
                    {snippet messages}
                        {foreach $messages as $message}
                            {if !$message->isHidden()}
                                <li class="{$message->getType()}">
                                    <p>{$message->getText()}</p>
                                </li>
                            {/if}
                        {/foreach}
                    {/snippet}
                </ul>
            </div>

            <div class="message-input">
                <div class="wrap">
                    <input type="text" placeholder="Write your message..."/>
                    <i class="far fa-question-circle attachment mt-2 pt-2" aria-hidden="true" data-toggle="modal"
                       data-target="#modalHelp"></i>
                    <button class="submit"><i class="fa fa-paper-plane" aria-hidden="true"></i></button>
                </div>
            </div>
        </div>
    </div>
    <div class="text-center">
        <a class="btn btn-reset" href="{plink Default:reset}"><i class="fas fa-redo"></i> Start over</a>
    </div>
</div>

<div class="modal fade" id="modalHelp" tabindex="-1" role="dialog" aria-labelledby="modalHelpTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content" style="border-radius: 0!important;">
            <div class="modal-header">
                <h5 class="modal-title" id="modalHelpTitle">Help</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <p>Write your message into the text field, send it with the submit button or by pressing enter, and wait for a response from the bot.</p>
                <hr>
                <p>If you are not sure what to answer to a bot's question, try asking him what are your choices,
                    e.g.:</p>
                <ul>
                    <li>"Help", "What are my options?", or "What are the choices?".</li>
                </ul>
                <hr>
                <p>
                    Write "I changed my mind" to cancel the current conversation and to select a different platform
                </p>
                <hr>
                <p>Reset the entire conversation by pressing the "Start over" button.</p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-reset" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

{snippet scrollToBottom}
    <script>
        $(".messages").animate({ scrollTop: $(".messages").prop("scrollHeight") }, "fast");
    </script>
{/snippet}

<script>
    let chatbotWaitingForResponse = false;

    function newMessage() {
        let message = $(".message-input input").val();
        if ($.trim(message) == '') {
            return false;
        }
        chatbotWaitingForResponse = true;
        $.nette.ajax({
            url: {link newMessage},
            data: {
                "chatFrame-inputText": message
            }
        }).done(() => {
            $('.message-input input').val(null);
            $.nette.ajax({
                url: {link sendMessage},
                data: {
                    "chatFrame-inputText": message
                }
            }).done(() => {
                chatbotWaitingForResponse = false;
            })
        });
    }

    $('.submit').click(function () {
        if (!chatbotWaitingForResponse) {
            newMessage();
        }
    });

    $(window).on('keydown', function (e) {
        if (e.which == 13 && !chatbotWaitingForResponse) {
            newMessage();
            return false;
        }
    });
</script>